package com.example.cursorloadertester;

import android.app.ListActivity;
import android.app.LoaderManager;
import android.content.CursorLoader;
import android.content.Loader;
import android.database.Cursor;
import android.os.Bundle;
import android.view.Menu;
import android.widget.SimpleCursorAdapter;

public class CursorLoaderTester extends ListActivity implements
LoaderManager.LoaderCallbacks<Cursor>{

	
	private static final int URL_LOADER = 0;
	SimpleCursorAdapter mAdapter = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
			// Sets the adapter for the view
		
	    mAdapter = new SimpleCursorAdapter(
        this,                // Current context
        R.layout.two_line_list_item,  // Layout for a single row
        null,                // No Cursor yet
        new String[] {Widget.NAME, Widget.TYPE},        // Cursor columns to use
        new int[] {R.id.text1, R.id.text2},           // Layout fields to use
        0                    // No flags
);

		
		    setListAdapter(mAdapter);
			getLoaderManager().initLoader(URL_LOADER, null, this);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	@Override
	public Loader<Cursor> onCreateLoader(int loaderID, Bundle bundle)
	{
	    /*
	     * Takes action based on the ID of the Loader that's being created
	     */
	    switch (loaderID) {
	        case URL_LOADER:
	            // Returns a new CursorLoader
	            return new CursorLoader(
	                        this,   // Parent activity context
	                        Widget.CONTENT_URI,        // Table to query
	                        null,     // Projection to return
	                        null,            // No selection clause
	                        null,            // No selection arguments
	                        null             // Default sort order
	        );
	        default:
	            // An invalid id was passed in
	            return null;
	    }
	}
	
	@Override
	public void onLoadFinished(Loader<Cursor> loader, Cursor cursor) {
	    /*
	     * Moves the query results into the adapter, causing the
	     * ListView fronting this adapter to re-display
	     */	
	 mAdapter.changeCursor(cursor);
	}	

	
	@Override
	public void onLoaderReset(Loader<Cursor> loader) {
	    
	    /*
	     * Clears out the adapter's reference to the Cursor.
	     * This prevents memory leaks.
	     */
	 mAdapter.changeCursor(null);
	}
}
